; This is a simple teletype device demonstrating the power of PCC's
; printer module. It uses variables to carry over status information.
; It simulates underlining by inserting extra lines containing "-" signs
; below the underlined characters, and "="s under bold characters.
; Those variables are used:
;   U is the extra line used for underlining
;   X keeps track of the X position on the line
;   V is a temporary variable (used in Newline). The last expression in
;     a line is the one finally arriving at the printer, so we can't
;     output the value of U and then set it to "".
; Note that this is not the only solution for this problem, see
; UNDERLI2.CCP for an alternate solution

Desc            ASCII with underlining (#1)
Init            X:=0; U:=""
Done            FF
Newline         V:=U; U:=""; X:=0; IF(V="", "", CR+LF+V)+CR+LF
Normal          X:=X+LEN(S); S
Bold            U:=U+STRING(X-LEN(U)," ")+STRING(LEN(S),"="); X:=X+LEN(S); S
Underline       U:=U+STRING(X-LEN(U)," ")+STRING(LEN(S),"-"); X:=X+LEN(S); S
